<?php

////////////////////////////////////////////////////////////////////////////////
//
// File:	function.SocialBookmarking.php
// Project:	Social Bookmarking plugin for CMS Made Simple
// Version:	1.8
// Licence:	Free software under the GNU General Public License
// Web:		http://dev.cmsmadesimple.org/projects/socialbks
// Created:	20060110, v1.0, Paul Hodgson
// Updated:	20091228, v1.2, Eduardo Martinez (hexdj)
// Updated:	20110605, v1.3, Andrea Weichbrodt (wich)
// Updated:	20110614, v1.4, Andrea Weichbrodt (wich)
// Updated:	20111031, v1.5, Andrea Weichbrodt (wich)
// Updated:	20120215, v1.6, Andrea Weichbrodt (wich)
// Updated:	20120518, v1.7, Andrea Weichbrodt (wich)
// Updated:	20120724, v1.8, Andrea Weichbrodt (wich)
// Updated:	20130827, v1.9, Eduardo Martinez (hexdj)
//
////////////////////////////////////////////////////////////////////////////////

function smarty_function_SocialBookmarking($params, &$smarty) {	

	$url_array = array(

		"email" => array("url" => "mailto:?subject=[title]&amp;body=[thisurl]",
					"alt" => "Email",
					"image" => "email.png",
					"title" => "Send by Email"),

		"a1webmarks" => array("url" => "http://www.a1-webmarks.com/bm_edit.html?t=[title]&amp;u=[thisurl]",
					"alt" => "A1-Webmarks",
					"image" => "a1webmarks.png",
					"title" => "Add webmark"),

		"adfty" => array("url" => "http://www.adfty.com/submit.php?url=[thisurl]",
					"alt" => "Adfty",
					"image" => "adfty.png",
					"title" => "Add to Adfty"),

		"allvoices" => array("url" => "http://www.allvoices.com/post_event?url=[thisurl]&amp;title=[title]",
					"alt" => "ALLVOICES",
					"image" => "allvoices.png",
					"title" => "Submit to ALLVOICES"),

		"bebo" => array("url" => "http://www.bebo.com/c/share?Url=[thisurl]&amp;Title=[title]",
					"alt" => "Bebo",
					"image" => "bebo.png",
					"title" => "Share on Bebo"),

		"bibsonomy" => array("url" => "http://www.bibsonomy.org/ShowBookmarkEntry?c=b&amp;jump=yes&amp;url=[thisurl]&amp;description=[title]",
					"alt" => "BibSonomy",
					"image" => "bibsonomy.png",
					"title" => "Bookmark this page to BibSonomy"),

		"blinklist" => array("url" => "http://blinklist.com/index.php?Action=Blink/addblink.php&amp;url=[thisurl]",
					"alt" => "BlinkList",
					"image" => "blinklist.png",
					"title" => "Submit to BlinkList"),

		"blogged" => array("url" => "http://www.blogged.com/submitarticle.php?url=[thisurl]&amp;title=[title]",
					"alt" => "Blogged",
					"image" => "blogged.png",
					"title" => "Submit Your Blog"),

		"blogmarks" => array("url" => "http://blogmarks.net/my/new.php?mini=1&amp;url=[thisurl]&amp;title=[title]",
					"alt" => "Blogmarks",
					"image" => "blogmarks.png",
					"title" => "Share on Blogmarks"),

		"brainify" => array("url" => "http://www.brainify.com/Bookmark.aspx?url=[thisurl]&amp;title=[title]",
					"alt" => "Brainify",
					"image" => "brainify.png",
					"title" => "Bookmark on Brainify"),

		"buddymarks" => array("url" => "http://buddymarks.com/add_bookmark.php?bookmark_title=[title]&amp;bookmark_url=[thisurl]",
					"alt" => "Buddymarks",
					"image" => "buddymarks.png",
					"title" => "Submit to Buddymarks"),

		"busexchange" => array("url" => "http://bx.businessweek.com/api/add-article-to-bx.tn?url=[thisurl]",
					"alt" => "Business Exchange",
					"image" => "busexchange.png",
					"title" => "Add to Business Exchange"),

		"buzzup" => array("url" => "http://buzz.yahoo.com/submit/?submitUrl=[thisurl]",
					"alt" => "buzzup",
					"image" => "buzzup.png",
					"title" => "Submit to buzzup"),

		"chiq" => array("url" => "http://www.chiq.com/create/affiliate?url=[thisurl]&amp;title=[title]",
					"alt" => "CHIQ",
					"image" => "chiq.png",
					"title" => "Add to CHIQ"),

		"citeulike" => array("url" => "http://www.citeulike.org/posturl?url=[thisurl]&amp;title=[title]",
					"alt" => "CiteUlike",
					"image" => "citeulike.png",
					"title" => "Share on CiteUlike"),

		"connotea" => array("url" => "http://www.connotea.org/addpopup?continue=confirm&amp;uri=[thisurl]&amp;title=[title]",
					"alt" => "Connotea",
					"image" => "connotea.png",
					"title" => "Share on Connotea"),

		"corank" => array("url" => "http://www.corank.com/submit?url=[thisurl]&amp;title=[title]&amp;source=w",
					"alt" => "coRank",
					"image" => "corank.png",
					"title" => "Submit to coRank"),

		"corkboard" => array("url" => "http://www.corkboard.it/posting/create?posting%5Btitle%5D=[title]&amp;posting%5Burl%5D=[thisurl]",
					"alt" => "Corkboard",
					"image" => "corkboard.png",
					"title" => "Corkboard it"),

		"current" => array("url" => "http://current.com/clipper.htm?url=[thisurl]&amp;title=[title]",
					"alt" => "Current",
					"image" => "current.png",
					"title" => "Invia a Current"),

		"delicious" => array("url" => "http://del.icio.us/post?url=[thisurl]&amp;title=[title]",
					"alt" => "del.icio.us",
					"image" => "delicious.png",
					"title" => "Submit to del.icio.us"),

		"designfloat" => array("url" => "http://www.designfloat.com/submit.php?url=[thisurl]",
					"alt" => "DesignFloat",
					"image" => "designfloat.png",
					"title" => "Float This"),

		"digg" => array("url" => "http://digg.com/submit?phase=2&amp;url=[thisurl]&amp;title=[title]",
					"alt" => "digg",
					"image" => "digg.png",
					"title" => "Submit to digg"),

		"diigo" => array("url" => "http://www.diigo.com/post?url=[thisurl]&amp;title=[title]",
					"alt" => "Diigo",
					"image" => "diigo.png",
					"title" => "Post to Diigo"),

		"dotnetkicks" => array("url" => "http://www.dotnetkicks.com/kick/?title=[title]&amp;url=[thisurl]",
					"alt" => "DotNetKicks.com",
					"image" => "dotnetkicks.png",
					"title" => "Kick It on DotNetKicks.com"),

		"dotnetshoutout" => array("url" => "http://dotnetshoutout.com/submit?url=[thisurl]",
					"alt" => ".Net Shoutout",
					"image" => "dotnetshoutout.png",
					"title" => "Shout it"),

		"douban" => array("url" => "http://www.douban.com/recommend/?url=[thisurl]&amp;title=[title]",
					"alt" => "Douban",
					"image" => "douban.png",
					"title" => "Submit to Douban"),

		"dzone" => array("url" => "http://www.dzone.com/links/add.html?url=[thisurl]&amp;title=[title]",
					"alt" => "DZone",
					"image" => "dzone.png",
					"title" => "Share on DZone"),

		"ekudos" => array("url" => "http://www.ekudos.nl/artikel/nieuw?url=[thisurl]&amp;title=[title]&amp;desc=[title]",
					"alt" => "eKudos",
					"image" => "ekudos.png",
					"title" => "Plaats op eKudos"),

		"evernote" => array("url" => "http://www.evernote.com/clip.action?url=[thisurl]&amp;title=[title]",
					"alt" => "Evernote",
					"image" => "evernote.png",
					"title" => "Clip to Evernote"),

		"facebook" => array("url" => "http://www.facebook.com/share.php?u=[thisurl]",
					"alt" => "facebook",
					"image" => "facebook.png",
					"title" => "Post to facebook"),

		"fark" => array("url" => "http://www.fark.com/cgi/farkit.pl?u=[thisurl]&amp;h=[title]",
					"alt" => "Fark",
					"image" => "fark.png",
					"title" => "Fark It"),

		"faves" => array("url" => "http://faves.com/Authoring.aspx?u=[thisurl]&amp;t=[title]",
					"alt" => "Faves",
					"image" => "faves.png",
					"title" => "Fave It"),

		"favoriten" => array("url" => "http://www.favoriten.de/url-hinzufuegen.html?bm_url=[thisurl]&amp;bm_title=[title]",
					"alt" => "Favoriten",
					"image" => "favoriten.png",
					"title" => "Diese Seite zu Favoriten.de hinzuf&uuml;gen"),

		"folkd" => array("url" => "http://www.folkd.com/submit/[thisurl]",
					"alt" => "folkd.com",
					"image" => "folkd.png",
					"title" => "Folk it"),

		"formspring" => array("url" => "http://www.formspring.me/button/index?url=[thisurl]&amp;title=[title]&amp;style=normal",
					"alt" => "Formspring",
					"image" => "formspring.png",
					"title" => "Submit to Formspring"),

		"fresqui" => array("url" => "http://fresqui.com/enviar?url=[thisurl]&amp;titulo=[title]",
					"alt" => "fresqui",
					"image" => "fresqui.png",
					"title" => "Enviar a Fresqui"),

		"friendfeed" => array("url" => "http://friendfeed.com/?url=[thisurl]&amp;title=[title]",
					"alt" => "FriendFeed",
					"image" => "friendfeed.png",
					"title" => "Share on FriendFeed"),

		"funp" => array("url" => "http://funp.com/push/submit/add.php?url=[thisurl]&amp;s=[title]&amp;via=tools",
					"alt" => "funP",
					"image" => "funp.png",
					"title" => "funP"),

		"furl" => array("url" => "http://www.furl.net/storeIt.jsp?u=[thisurl]&amp;t=[title]",
					"alt" => "furl.net",
					"image" => "furl.png",
					"title" => "Submit to furl.net"),

		"fwisp" => array("url" => "http://fwisp.com/submit?url=[thisurl]",
					"alt" => "fwisp",
					"image" => "fwisp.png",
					"title" => "Share on fwisp"),

		"google" => array("url" => "http://www.google.com/bookmarks/mark?op=add&amp;bkmk=[thisurl]&amp;title=[title]",
					"alt" => "Google Bookmarks",
					"image" => "google.png",
					"title" => "Submit to Google Bookmarks"),

		"googletranslate" => array("url" => "http://translate.google.com/translate?u=[thisurl]",
					"alt" => "Google Translate",
					"image" => "googletranslate.png",
					"title" => "Translate this page with Google"),

		"googleplus" => array("url" => "https://plus.google.com/share?url=[thisurl]",
					"alt" => "Google+",
					"image" => "googleplus.png",
					"title" => "Submit to Google+"),

		"hyves" => array("url" => "http://hyves-share.nl/button/tip/?tipcategoryid=12&amp;rating=5&amp;title=[title]&amp;body=[thisurl]",
					"alt" => "Hyves",
					"image" => "hyves.png",
					"title" => "Share on Hyves"),

		"instapaper" => array("url" => "http://www.instapaper.com/hello2?url=[thisurl]&amp;title=[title]",
					"alt" => "Instapaper",
					"image" => "instapaper.png",
					"title" => "Save this for later with Instapaper"),

		"jamespot" => array("url" => "http://www.jamespot.com/?action=spotit&amp;url=[thisurl]&amp;title=[title]",
					"alt" => "Spot It",
					"image" => "jamespot.png",
					"title" => "Add to Jamespot"),

		"jumptags" => array("url" => "http://www.jumptags.com/add/?url=[thisurl]&amp;title=[title]",
					"alt" => "Jumptags",
					"image" => "jumptags.png",
					"title" => "Add Jumptag"),

		"linkagogo" => array("url" => "http://www.linkagogo.com/go/AddNoPopup?title=[title]&amp;url=[thisurl]",
					"alt" => "linkaGoGo",
					"image" => "linkagogo.png",
					"title" => "Add to linkaGoGo"),

		"linkarena" => array("url" => "http://linkarena.com/bookmarks/addlink/?url=[thisurl]&amp;title=[title]",
					"alt" => "LinkARENA",
					"image" => "linkarena.png",
					"title" => "Bei LinkARENA sichern"),

		"linkedin" => array("url" => "http://www.linkedin.com/shareArticle?mini=true&amp;url=[thisurl]",
					"alt" => "LinkedIn",
					"image" => "linkedin.png",
					"title" => "Post to LinkedIn"),

		"linksilo" => array("url" => "http://www.linksilo.de/index.php?area=bookmarks&amp;func=bookmark_new&amp;addurl=[thisurl]&amp;addtitle=[title]",
					"alt" => "Linksilo",
					"image" => "linksilo.png",
					"title" => "Diese Website bei linksilo.de bookmarken"),

		"live" => array("url" => "https://favorites.live.com/quickadd.aspx?marklet=1&amp;url=[thisurl]&amp;title=[title]",
					"alt" => "Live.com",
					"image" => "live.png",
					"title" => "Add to Live.com"),
					
		"mailru" => array("url" => "http://connect.mail.ru/share?share_url=[thisurl]",
					"alt" => "Mail.ru",
					"image" => "mailru.png",
					"title" => "Nravitsya MailRu"),					

		"meneame" => array("url" => "http://meneame.net/submit.php?url=[thisurl]&amp;title=[title]",
					"alt" => "Men&eacute;ame",
					"image" => "meneame.png",
					"title" => "Submit to Men&eacute;ame"),

		"misterwong" => array("url" => "http://www.mister-wong.com/index.php?action=addurl&amp;bm_url=[thisurl]&amp;bm_description=[title]",
					"alt" => "Mister Wong",
					"image" => "misterwong.png",
					"title" => "Add this page to Mister Wong"),

		"mixx" => array("url" => "http://www.mixx.com/submit?page_url=[thisurl]",
					"alt" => "mixx",
					"image" => "mixx.png",
					"title" => "Submit to mixx"),

		"myspace" => array("url" => "http://www.myspace.com/Modules/PostTo/Pages/?l=3&amp;u=[thisurl]",
					"alt" => "Myspace",
					"image" => "myspace.png",
					"title" => "Post to Myspace"),

		"n4g" => array("url" => "http://n4g.com/tips?url=[thisurl]&amp;title=[title]",
					"alt" => "N4G",
					"image" => "n4g.png",
					"title" => "Tips N4G about this story"),

		"netlog" => array("url" => "http://www.netlog.com/go/manage/links/view=save&amp;origin=external&amp;url=[thisurl]&amp;title=[title]&amp;description=[title]",
					"alt" => "Netlog",
					"image" => "netlog.png",
					"title" => "Submit to Netlog"),

		"netvibes" => array("url" => "http://www.netvibes.com/share?title=[title]&amp;url=[thisurl]",
					"alt" => "Netvibes",
					"image" => "netvibes.png",
					"title" => "Share on Netvibes"),

		"netvouz" => array("url" => "http://www.netvouz.com/action/submitBookmark?url=[thisurl]&amp;title=[title]&amp;popup=no",
					"alt" => "Netvouz",
					"image" => "netvouz.png",
					"title" => "Submit to Netvouz"),

		"newsvine" => array("url" => "http://www.newsvine.com/_wine/save?u=[thisurl]&amp;h=[title]",
					"alt" => "newsvine.com",
					"image" => "newsvine.png",
					"title" => "Submit to newsvine.com"),

		"nujij" => array("url" => "http://nujij.nl/jij.lynkx?t=[title]&amp;u=[thisurl]",
					"alt" => "NUjij.nl",
					"image" => "nujij.png",
					"title" => "Submit to NUjij"),
					
		"odnoklassniki" => array("url" => "http://www.odnoklassniki.ru/dk?st.cmd=addShare&amp;st.s=1000&amp;st._surl=[thisurl]",
					"alt" => "Klass!",
					"image" => "klass.png",
					"title" => "Share on odnoklassniki.ru"),			

		"oknotizie" => array("url" => "http://oknotizie.virgilio.it/post.html.php?url=[thisurl]&amp;title=[title]",
					"alt" => "OKNOtizie",
					"image" => "oknotizie.png",
					"title" => "Condividi su OKNOtizie"),

		"oneview" => array("url" => "http://www.oneview.com/add/?url=[thisurl]&amp;title=[title]",
					"alt" => "oneview",
					"image" => "oneview.png",
					"title" => "Add to oneview"),

		"orkut" => array("url" => "http://promote.orkut.com/preview?nt=orkut.com&amp;du=[thisurl]&amp;tt=[title]",
					"alt" => "Orkut",
					"image" => "orkut.png",
					"title" => "Share on Orkut"),

		"pinboard" => array("url" => "https://pinboard.in/add?url=[thisurl]&amp;description=[title]&amp;title=[title]",
					"alt" => "Pinboard",
					"image" => "pinboard.png",
					"title" => "Save to Pinboard"),		

		"pinterest" => array("url" => "http://pinterest.com/pin/create/button/?url=[thisurl]",
					"alt" => "Pinterest",
					"image" => "pinterest.png",
					"title" => "Add to Pinterest"),								

		"plaxo" => array("url" => "http://www.plaxo.com/events?share_link=[thisurl]",
					"alt" => "Plaxo",
					"image" => "plaxo.png",
					"title" => "Share on Plaxo"),

		"posterous" => array("url" => "http://posterous.com/share?linkto=[thisurl]&amp;title=[title]",
					"alt" => "Posterous",
					"image" => "posterous.png",
					"title" => "Share on Posterous"),

		"reddit" => array("url" => "http://reddit.com/submit?url=[thisurl]&amp;title=[title]",
					"alt" => "reddit.com",
					"image" => "reddit.png",
					"title" => "Submit to reddit.com"),

		"renren" => array("url" => "http://share.renren.com/share/buttonshare.do?link=[thisurl]&amp;title=[title]",
					"alt" => "Renren",
					"image" => "renren.png",
					"title" => "Share on Renren"),

		"scribd" => array("url" => "http://www.scribd.com/everywhere/scribble?t=[title]&amp;u=[thisurl]",
					"alt" => "Scribd",
					"image" => "scribd.png",
					"title" => "Post this to Scribd"),

		"segnalo" => array("url" => "http://segnalo.alice.it/post.html.php?url=[thisurl]&amp;title=[title]&amp;descr=[title]",
					"alt" => "Segnalo",
					"image" => "segnalo.png",
					"title" => "Posta su Segnalo"),

		"seoigg" => array("url" => "http://www.seoigg.de/node/add/storylink?edit&#91;url&#93;=[thisurl]&amp;edit&#91;title&#93;=[title]",
					"alt" => "SEOigg",
					"image" => "seoigg.png",
					"title" => "Beitrag bei SEOigg hinzuf&uuml;gen"),

		"slashdot" => array("url" => "http://slashdot.org/slashdot-it.pl?op=basic&amp;url=[thisurl]",
					"alt" => "Slashdot",
					"image" => "slashdot.png",
					"title" => "Send to Slashdot"),

		"sonico" => array("url" => "http://www.sonico.com/share.php?title=[title]&amp;url=[thisurl]",
					"alt" => "Sonico",
					"image" => "sonico.png",
					"title" => "Share in Sonico"),

		"sphinn" => array("url" => "http://sphinn.com/submit.php?url=[thisurl]&amp;title=[title]",
					"alt" => "Sphinn",
					"image" => "sphinn.png",
					"title" => "Share in Sphinn"),

		"startlap" => array("url" => "http://www.startlap.hu/sajat_linkek/addlink.php?url=[thisurl]&amp;title=[title]",
					"alt" => "Startlap",
					"image" => "startlap.png",
					"title" => "Add a Startlaphoz"),

		"stumbleupon" => array("url" => "http://www.stumbleupon.com/submit?url=[thisurl]&amp;title=[title]",
					"alt" => "stumbleupon",
					"image" => "stumbleupon.png",
					"title" => "Submit to StumbleUpon"),

		"stumpedia" => array("url" => "http://www.stumpedia.com/submit?url=[thisurl]",
					"alt" => "Stumpedia",
					"image" => "stumpedia.png",
					"title" => "Submit to Stumpedia"),

		"technorati" => array("url" => "http://technorati.com/faves?add=[thisurl]",
					"alt" => "technorati.com",
					"image" => "technorati.png",
					"title" => "Submit to technorati.com"),

		"trunkly" => array("url" => "http://trunk.ly/submit/?u=[thisurl]&amp;t=[title]&amp;notes=[title]&amp;v=1&amp;jump=yes",
					"alt" => "Trunk.ly",
					"image" => "trunkly.png",
					"title" => "Save into Trunk.ly"),

		"tumblr" => array("url" => "http://www.tumblr.com/share/link?url=[thisurl]&amp;name=[title]&amp;description=[title]",
					"alt" => "Tumblr",
					"image" => "tumblr.png",
					"title" => "Share on Tumblr"),

		"twitter" => array("url" => "http://twitter.com/share?url=[thisurl]&amp;text=[title]",
					"alt" => "twitter",
					"image" => "twitter.png",
					"title" => "Tweet"),

		"upnews" => array("url" => "http://www.upnews.it/submit?url=[thisurl]&amp;title=[title]",
					"alt" => "Upnews.it",
					"image" => "upnews.png",
					"title" => "Proponi su Upnews.it"),

		"vk" => array("url" => "http://vkontakte.ru/share.php?url=[thisurl]",
					"alt" => "VK",
					"image" => "vk.png",
					"title" => "Post to VK"),

		"xerpi" => array("url" => "http://www.xerpi.com/favorite/post?url=[thisurl]&amp;title=[title]",
					"alt" => "Xerpi",
					"image" => "xerpi.png",
					"title" => "Post to Xerpi"),

		"yahoo" => array("url" => "http://myweb2.search.yahoo.com/myresults/bookmarklet?u=[thisurl]&amp;t=[title]",
					"alt" => "yahoo",
					"image" => "yahoo.png",
					"title" => "Submit to Yahoo"),

		"yigg" => array("url" => "http://yigg.de/neu?exturl=[thisurl]&amp;exttitle=[title]",
					"alt" => "YiGG",
					"image" => "yigg.png",
					"title" => "Submit to YiGG.de")

	);

	$gCms = cmsms();

	$title_prefix = isset($params['title']) ? $params['title'] : ""; // page title prefix
	$link_target = isset($params['target']) ? $params['target'] : ""; // _blank etc.
	$class = isset($params['class']) ? ' class="' . trim($params['class']) . '"' : ""; // CSS class
	$id = isset($params['id']) ? ' id="' . trim($params['id']) . '"' : ""; // CSS id
	$submitto = isset($params['submitto']) ? strtolower($params['submitto']) : ""; // array containing list of sites to print links to
	$img_dir = isset($params['img_dir']) ? $params['img_dir'] : ""; // directory images are uploaded to
	$img_size = isset($params['img_size']) ? strtolower($params['img_size']) : ""; // size of images: accepted values are big (32px default), small (16px) or none (only textual links without images)
	$text_separator = isset($params['text_separator']) ? $params['text_separator'] : " | "; // text separator used if img_size is set to none (default value is a pipe)
	$real_url = (isset($params['real_url']) && $params['real_url']);
	$plusone = (isset($params['plusone']) && $params['plusone']); // Google +1
	$plusone_lang = isset($params['plusone_lang']) ? '{lang: \'' . trim($params['plusone_lang']) . '\'}' : ""; // Google+1 language (en-US default)	
	$custom_title = isset($params['custom_title']) ? trim($params['custom_title']) : ""; // set manually the title of the current page without self detection functionality
	$custom_url = isset($params['custom_url']) ? trim($params['custom_url']) : ""; // set manually the url of the current page without self detection functionality
	
	if ($custom_title != "") {
		// manually set
		$curtitle = $custom_title;
	} else {
		// self detection
		$pageinfo =& $gCms->variables['pageinfo'];
		$curtitle = $title_prefix . cms_htmlentities($pageinfo->content_title);
	}
	$curtitle = urlencode($curtitle); // title of the page

	if ($custom_url != "") {
		// manually set
		$url = $custom_url;
	} else {
		// self detection
		if($real_url){
			$isHTTPS = (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on");
			$port = (isset($_SERVER["SERVER_PORT"]) && ((!$isHTTPS && $_SERVER["SERVER_PORT"] != "80") || ($isHTTPS && $_SERVER["SERVER_PORT"] != "443")));
			$port = ($port) ? ':' . $_SERVER["SERVER_PORT"] : '';
			$url = ($isHTTPS ? 'https://' : 'http://') . $_SERVER["SERVER_NAME"] . $port . $_SERVER["REQUEST_URI"];
		} else {
			$hm =& $gCms->GetHierarchyManager();
			$page_content_id = $gCms->variables['content_id'];
			$curnode =& $hm->getNodeById($page_content_id);
			$curcontent =& $curnode->GetContent();
			$url = $curcontent->GetURL();
		}
	}	
	$url = urlencode($url); // url of the page

	if ($link_target != "") {
		$target = ' target="' .$link_target. '"';
	} else {
		$target = "";
	}

	if ($img_dir == "") {
		$img_dir = "images/socialbookmarking/";
	}

	switch ($img_size) {
		case "big":
			$img_size = "32";
			break;
		case "small":
			$img_size = "16";
			break;
		case "none":
			$img_size = "0";
			break;
		default:
			$img_size = "32";
	}

	$result = "";
	$result .= '<!-- Start Social Bookmarking plugin -->' . PHP_EOL;

	if ($submitto == "all" || $submitto == "") {
		foreach ($url_array as $value) {
			$print_url = str_replace("[thisurl]", $url, $value["url"]);
			$print_url = str_replace("[title]", $curtitle, $print_url);
			if ($img_size != "0") {
				$result .= '<a href="' . $print_url . '"';
				$result .= ' title="' . $value["title"] . '"';
				$result .= ' rel="nofollow"';
				$result .= $target;
				$result .= $class;
				$result .= $id;
				$result .= '>';
				$result .= '<img src="' . $img_dir.$value["image"] . '"';
				$result .= ' alt="' . $value["alt"] . '"';
				$result .= ' title="' . $value["title"] . '"';
				$result .= ' width="' . $img_size . '"';
				$result .= ' height="' . $img_size . '" />';
				$result .= '</a>';
				$result .= ' ' . PHP_EOL;
			} else {
				$result .= '<a href="' . $print_url . '"';
				$result .= ' title="' . $value["title"] . '"';
				$result .= ' rel="nofollow"';
				$result .= $target;
				$result .= $class;
				$result .= $id;
				$result .= '>';
				$result .= $value["title"];
				$result .= '</a>';
				$result .= $text_separator . PHP_EOL;
			}
		}
	} else {
		$submit_array = explode("|", $submitto);
		foreach($submit_array as $value) {
			$print_url = str_replace("[thisurl]", $url, $url_array[$value]["url"]);
			$print_url = str_replace("[title]", $curtitle, $print_url);
			if ($img_size != "0") {
				$result .= '<a href="' . $print_url . '"';
				$result .= ' title="' . $url_array[$value]["title"] . '"';
				$result .= ' rel="nofollow"';
				$result .= $target;
				$result .= $class;
				$result .= $id;
				$result .= '>';
				$result .= '<img src="' . $img_dir . $url_array[$value]["image"] . '" ';
				$result .= 'alt="' . $url_array[$value]["alt"] . '"';
				$result .= ' title="' . $url_array[$value]["title"] . '"';
				$result .= ' width="' . $img_size . '"';
				$result .= ' height="' . $img_size . '" />';
				$result .= '</a>';
				$result .= ' ' . PHP_EOL;
			} else {
				$result .= '<a href="' . $print_url . '"';
				$result .= ' title="' . $url_array[$value]["title"] . '"';
				$result .= ' rel="nofollow"';
				$result .= $target;
				$result .= $class;
				$result .= $id;
				$result .= '>';
				$result .= $url_array[$value]["title"];
				$result .= '</a>';
				$result .= $text_separator . PHP_EOL;
			}
		}
	}

	// Google +1
	if($plusone){
		$result .= '<script type="text/javascript" src="https://apis.google.com/js/plusone.js">' . $plusone_lang . '</script>' . PHP_EOL;
		// this line of code can't pass the w3.org validation service
		// $result .= '<g:plusone></g:plusone>' . PHP_EOL;
		// this is much better
		$result .= '<div class="g-plusone"></div>' . PHP_EOL;
	}

	$result .= '<!-- End Social Bookmarking plugin -->';

	return $result;

}

function smarty_cms_help_function_SocialBookmarking() {
	?>
	<h3>What does this do?</h3>
	<p style="color:red">Please update your calls to {SocialBookmarking} (notice the capital S) the old call with lowercase S was causing issues with current CMSMS versions. Also please delete plugins/function.socialBookmarking.php (old version) to avoid possible conflicts.</p>
	<br />
	<p>Prints links to submit the page to up to 90 social bookmarks managers like: A1-Webmarks, Adfty, ALLVOICES, Bebo, BibSonomy, BlinkList, Blogged, Blogmarks, Brainify, Buddymarks, Business Exchange, Buzzup, CHIQ, CiteUlike, Connotea, coRank, Corkboard, Current, del.icio.us, DesignFloat, Digg, Diigo, DotNetKicks, .Net Shoutout, Douban, DZone, eKudos, Evernote, Facebook, Fark, Faves, Favoriten, Folkd, Formspring, Fresqui, FriendFeed, funP, Furl, fwisp, Google+1, Google Bookmarks, Google Translate, Google Plus, Hyves, Instapaper, Jamespot, Jumptags, linkaGoGo, LinkARENA, LinkedIn, Linksilo, Live.com, MailRu, Men&eacute;ame, Mister Wong, Mixx, Myspace, N4G, Netlog, Netvibes, Netvouz, Newsvine, NUjij, Odnoklassniki.ru, OKNOtizie, Oneview, Orkut, Pinboard, Pinterest, Plaxo, Posterous, Reddit, Renren, Scribd, Segnalo, SEOigg, Slashdot, Sonico, Sphinn, Startlap, StumbleUpon, Stumpedia, Technorati, Trunk.ly, Tumblr, Twitter, Upnews, Xerpi, VK, Yahoo, YiGG, or by Email.</p>
	<h3>How do I use it?</h3>
	<p>Insert the tag <code>{SocialBookmarking}</code> into your template or page (please notice the lowercase 's' in the tag).</p>
	<p>To ensure that web-designers have maximum control over customization, if you want to style the plugin's output, feel free to use additional external CSS rules in conjunction with the <code>class</code> or <code>id</code> parameter.</p>
	<h3>Using this plugin in conjunction with News and/or CGBlog module</h3>	
	<p>We all know that the <strong>page title</strong> of a news item detail (or CGBlog's article) by default isn't the title of the news item itself (or blog's article). Thats why, using this plugin in a news item (or blog's article) does not work as expected.</p>
	<p>Well, the solution exists, and it's easy! The Social Bookmarking plugin works fine... and you just have to modify the News module <strong>Detail Template</strong> (or CGBlog's Detail View Templates) and the <strong>Page Template</strong> of the site.</p>
	<ul>
	<li>Modify the News module <strong>Detail Template</strong> (or CGBlog's Detail View Templates) by adding this line at the beginning: <code>{assign var="pagetitle" value=$entry->title|escape}</code> (this line has the purpose of generating the Smarty variable <code>$pagetitle</code> containing the title of the news article or blog article)</li>
	<li>Modify the <strong>Page Template</strong> of the site by adding this line at the beginning: <code>{process_pagedata}</code></li>
	<li>Modify the <strong>Page Template</strong> of the site by replacing the title tag inside the head section <code>&lt;title&gt;{title} - {sitename}&lt;/title&gt;</code> with this code: <code>{if isset($pagetitle) && !empty($pagetitle)}&lt;title&gt;{$pagetitle} - {sitename}&lt;/title&gt;{else}&lt;title&gt;{title} - {sitename}&lt;/title&gt;{/if}</code> (this snippet checks if the <code>$pagetitle</code> variable is defined and not empty, if the variable exists the title of the news or blog will be used as the page title, otherwise the original title of the page will be used)</li>
	<li>Also make sure that <code>process_whole_template</code> is set to <code>false</code> in your <code>config.php</code> file (default setting): this setting will cause the <code>&lt;body&gt;</code> section is processed before the <code>&lt;head&gt;</code> section in the template</li>
	</ul>
	<p>This method is also applicable to other modules like CGCalendar, Products, etc.</p>
	<p>Alternatively, you can always use the <code>custom_url</code> and <code>custom_title</code> parameters to set manually (or pass them via smarty) the url and title values of the current page without self detection functionality.</p>
	<h3>What parameters does it take?</h3>
	<ul>
		<li><em>(optional)</em> <code>title</code></li>
		<ul>
			<li>Allows text to be prefixed as a constant to the title information</li>
			<li>This parameter is ignored if the <code>custom_title</code> parameter is set</li>
			<li>E.g. <code>{SocialBookmarking title="My Website - "}</code></li>
		</ul>
		<li><em>(optional)</em> <code>target</code></li>
		<ul>
			<li>Populates the "<code>target</code>" attribute of the link</li>
			<li>E.g. <code>{SocialBookmarking target="_blank"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>class</code></li>
		<ul>
			<li>Populates the "<code>class</code>" attribute of the link, set the CSS class name</li>
			<li>E.g. <code>{SocialBookmarking class="MyCssClassName"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>id</code></li>
		<ul>
			<li>Populates the "<code>id</code>" attribute of the link, set the CSS id name</li>
			<li>E.g. <code>{SocialBookmarking id="MyCssIdName"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>submitto</code></li>
		<ul>
			<li>Choose which Social Bookmark Managers to submit to</li>
			<li>Possible values (case-insensitive mode) separated by a pipe ("<code>|</code>"):</li>
			<ul>
				<li><code>all</code></li>
				<li><code>email</code></li>
				<li><code>a1webmarks</code></li>
				<li><code>adfty</code></li>
				<li><code>allvoices</code></li>
				<li><code>bebo</code></li>
				<li><code>bibsonomy</code></li>
				<li><code>blinklist</code></li>
				<li><code>blogged</code></li>
				<li><code>blogmarks</code></li>
				<li><code>brainify</code></li>
				<li><code>buddymarks</code></li>
				<li><code>busexchange</code></li>
				<li><code>buzzup</code></li>
				<li><code>chiq</code></li>
				<li><code>citeulike</code></li>
				<li><code>connotea</code></li>
				<li><code>corank</code></li>
				<li><code>corkboard</code></li>
				<li><code>current</code></li>
				<li><code>delicious</code></li>
				<li><code>designfloat</code></li>
				<li><code>digg</code></li>
				<li><code>diigo</code></li>
				<li><code>dotnetkicks</code></li>
				<li><code>dotnetshoutout</code></li>
				<li><code>douban</code></li>
				<li><code>dzone</code></li>
				<li><code>ekudos</code></li>
				<li><code>evernote</code></li>
				<li><code>facebook</code></li>
				<li><code>fark</code></li>
				<li><code>faves</code></li>
				<li><code>favoriten</code></li>
				<li><code>folkd</code></li>
				<li><code>formspring</code></li>
				<li><code>fresqui</code></li>
				<li><code>friendfeed</code></li>
				<li><code>funp</code></li>
				<li><code>furl</code></li>
				<li><code>fwisp</code></li>
				<li><code>google</code></li>
				<li><code>googletranslate</code></li>
				<li><code>googleplus</code></li>
				<li><code>hyves</code></li>
				<li><code>instapaper</code></li>
				<li><code>jamespot</code></li>
				<li><code>jumptags</code></li>
				<li><code>linkagogo</code></li>
				<li><code>linkarena</code></li>
				<li><code>linkedin</code></li>
				<li><code>linksilo</code></li>
				<li><code>live</code></li>
				<li><code>mailru</code></li>
				<li><code>meneame</code></li>
				<li><code>misterwong</code></li>
				<li><code>mixx</code></li>
				<li><code>myspace</code></li>
				<li><code>n4g</code></li>
				<li><code>netlog</code></li>
				<li><code>netvibes</code></li>
				<li><code>netvouz</code></li>
				<li><code>newsvine</code></li>
				<li><code>nujij</code></li>
				<li><code>odnoklassniki</code></li>
				<li><code>oknotizie</code></li>
				<li><code>oneview</code></li>
				<li><code>orkut</code></li>
				<li><code>pinboard</code></li>
				<li><code>pinterest</code></li>
				<li><code>plaxo</code></li>
				<li><code>posterous</code></li>
				<li><code>reddit</code></li>
				<li><code>renren</code></li>
				<li><code>scribd</code></li>
				<li><code>segnalo</code></li>
				<li><code>seoigg</code></li>
				<li><code>slashdot</code></li>
				<li><code>sonico</code></li>
				<li><code>sphinn</code></li>
				<li><code>startlap</code></li>
				<li><code>stumbleupon</code></li>
				<li><code>stumpedia</code></li>
				<li><code>technorati</code></li>
				<li><code>trunkly</code></li>
				<li><code>tumblr</code></li>
				<li><code>twitter</code></li>
				<li><code>upnews</code></li>
				<li><code>vk</code></li>
				<li><code>xerpi</code></li>
				<li><code>yahoo</code></li>
				<li><code>yigg</code></li>
			</ul>
			<li>The value <code>all</code> will print all supported Social Bookmark links</li>
			<li>The value <code>email</code> will print a <code>mailto</code> link</li>
			<li><strong>Important:</strong> if the value <code>all</code> is used, do not enter any other value</li>
			<li>Leaving this parameter blank, or not using this parameter will automatically print all supported Social Bookmark links</li>
			<li>E.g. <code>{SocialBookmarking submitto="email|facebook|twitter|linkedin"}</code></li>
			<li>E.g. <code>{SocialBookmarking submitto="all"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>plusone</code></li>
		<ul>
			<li>Set to <code>1</code> to print the Google+1 button</li>
			<li>Leave empty or set to <code>0</code> if you don't want to print the Google+1 button</li>
			<li>E.g. <code>{SocialBookmarking submitto="email|facebook|twitter|linkedin" plusone="1"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>plusone_lang</code></li>
		<ul>
			<li>Sets the language to use for Google+1 button on the page</li>
			<li>For available language code values, please see the list of supported language codes here: <a href="https://developers.google.com/+/plugins/+1button/#available-languages" target="_blank">https://developers.google.com/+/plugins/+1button/#available-languages</a></li>
			<li>Do NOT define if you want to print the Google+1 button in English (en-US)</li>
			<li>E.g. <code>{SocialBookmarking submitto="email|facebook|twitter|linkedin" plusone="1" plusone_lang="it"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>img_dir</code></li>
		<ul>
			<li>The directory you have uploaded the images to</li>
			<li>Do NOT define, or just leave BLANK if you have uploaded to the DEFAULT install directory <code>/images/socialbookmarking/</code></li>
			<li><strong>Important:</strong> if you define a directory, include the leading and trailing slashes ("<code>/</code>")</li>
			<li>E.g. <code>{SocialBookmarking img_dir="<strong>/</strong>my/image/directory<strong>/</strong>"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>img_size</code></li>
		<ul>
			<li>Do NOT define, or set to <code>big</code> to print the Social Bookmark links with 32x32 pixel images</li>
			<li>Set to <code>small</code> to print the Social Bookmark links with 16x16 pixel images</li>
			<li>Set to <code>none</code> to print only textual links without images</li>
			<li>E.g. <code>{SocialBookmarking img_size="big"}</code></li>
			<li>E.g. <code>{SocialBookmarking img_size="small"}</code></li>
			<li>E.g. <code>{SocialBookmarking img_size="none"}</code></li>
		</ul>
		<li><em>(optional)</em> <code>text_separator</code></li>
		<ul>
			<li>Text separator used if <code>img_size</code> parameter is set to <code>none</code>
			<li>Default value is a pipe between two spaces ("<code> | </code>")</li>
			<li>E.g. <code>{SocialBookmarking img_size="none" text_separator="&lt;br /&gt;"}</code></li>
			<li>E.g. <code>{SocialBookmarking img_size="none" text_separator=", "}</code></li>
		</ul>
		<li><em>(optional)</em> <code>real_url</code></li>
		<ul>
			<li>Leave empty or set to <code>0</code> to use the content page url without consideration for modules</li>
			<li>Set to <code>1</code> to use the real url</li>
			<li>This parameter is ignored if the <code>custom_url</code> parameter is set</li>
		</ul>		
		<li><em>(optional)</em> <code>custom_url</code></li>
		<ul>
			<li>Set manually the <strong>complete</strong> url of the current page without self detection functionality</li>
			<li>Useful with the output of modules or in conjunction with smarty variables</li>
			<li>If this parameter is set the <code>real_url</code> parameter is ignored</li>
			<li>E.g. <code>{SocialBookmarking custom_url="http://www.domain.ext/my/custom/url/of/the/current/page"}</code></li>
		</ul>		
		<li><em>(optional)</em> <code>custom_title</code></li>
		<ul>
			<li>Set manually the title of the current page without self detection functionality</li>
			<li>Useful with the output of modules or in conjunction with smarty variables</li>
			<li>If this parameter is set the <code>title</code> parameter (prefix) is ignored</li>
			<li>E.g. <code>{SocialBookmarking custom_title="My Custom Title Of The Current Page"}</code></li>
		</ul>		
	</ul>
	<?php
}

function smarty_cms_about_function_SocialBookmarking() {
	?>
	<p>Author: Paul Hodgson</p>
	<p>Updated by: Eduardo Martinez (hexdj)<br />
	Updated/Maintained by: Andrea Weichbrodt (wich)</p>
	<p>Version: 1.8</p>
	<p>Update: Check for updates for this plugin at the <a href="http://dev.cmsmadesimple.org/projects/socialbks" target="_blank">CMS Made Simple Forge page</a></p>
	<p>Feature Requests: If you want to add others social bookmarking services or functionality, please let me know by opening a new feature request in the dedicated <strong>Feature Requests tab</strong> of the <a href="http://dev.cmsmadesimple.org/projects/socialbks" target="_blank">CMS Made Simple Forge page</a> for this plugin</p>
	<p>Bugs: If you want to submit a new bug, please let me know by opening a new bug in the dedicated <strong>Bug Tracker tab</strong> of the <a href="http://dev.cmsmadesimple.org/projects/socialbks" target="_blank">CMS Made Simple Forge page</a> for this plugin</p>
	<p>Licence: Free software under the GNU General Public License</p>
	<p>Change History:</p>
	<ul>
		<li>Version 1.9 released on 20130828 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added Google+ (Google Plus)</li>
			<li>Added Pinterest</li>
			<li>Removed Google Buzz(no longer exists)</li>
			<li>Added flat, updated icons for: Facebook, Twitter, Evernote, Pinterest, Google+, Delicious</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.8 released on 20120724 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added the optional <code>custom_url</code> parameter to set manually the url of the current page without self detection functionality</li>
			<li>Added the optional <code>custom_title</code> parameter to set manually the title of the current page without self detection functionality</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.7 released on 20120518 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added VK, Odnoklassniki.ru, MailRu</li>
			<li>Added the optional <code>plusone_lang</code> parameter to set the language to use for Google+1 button on the page</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.6 released on 20120215 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added Google+1</li>
			<li>Updated Tumblr</li>
			<li>Added the optional <code>class</code> parameter to set the CSS class name for the link tag</li>
			<li>Added the optional <code>id</code> parameter to set the CSS id name for the link tag</li>
			<li>Added a <code>PHP_EOL</code> char after each link for clarify the output</li>
			<li>Added XHTML comment lines before and after the plugin for clarify the output</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.5 released on 20111031 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added A1-Webmarks, Adfty, BibSonomy, Blogged, Brainify, Business Exchange, CHIQ, coRank, Corkboard, Current, DotNetKicks, .Net Shoutout, Evernote, Faves, Favoriten, Folkd, Formspring, Fresqui, funP, fwisp, Google Translate, Instapaper, Jumptags, LinkARENA, Linksilo, Oneview, Pinboard, Scribd, Segnalo, SEOigg, Stumpedia, Trunk.ly, Xerpi, YiGG</li>
			<li>Updated Furl (only the image file)</li>
			<li>Updated Jamespot (only the image file)</li>
			<li>Fix security on <code>$gCms</code> declaration</li>
			<li>Added the option <code>none</code> for the <code>img_size</code> parameter, to print only textual links without images</li>
			<li>Added the <code>text_separator</code> parameter, to print a separator if <code>img_size</code> parameter is set to <code>none</code></li>
			<li>Added the <code>title</code> attribute to the <code>img</code> tag</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.4 released on 20110614 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added ALLVOICES, Bebo, Blogmarks, Buddymarks, CiteUlike, Connotea, DesignFloat, Diigo, Douban, DZone, eKudos, Fark, Google Buzz, Hyves, Jamespot, linkaGoGo, Live.com, Men&eacute;ame, Mister Wong, N4G, Netlog, Netvibes, Netvouz, NUjij, OKNOtizie, Orkut, Plaxo, Posterous, Renren, Slashdot, Sonico, Sphinn, Startlap, Tumblr, Upnews</li>
			<li>Added a mailto link</li>
			<li>Updated Digg, Technorati</li>
			<li>Removed ma.gnolia.com (web site closed)</li>
			<li>Updated images</li>
			<li>Added the <code>img_size</code> parameter, allowing a selection to be made, on which size (32x32 or 16x16 pixel) the Social Bookmarks link's images are output.</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.3 released on 20110605 by Andrea Weichbrodt (wich)</li>
		<ul>
			<li>Added Twitter, Friendfeed</li>
			<li>Updated Blinklist, Myspace, LinkedIn</li>
			<li>Now parameters can be passed in case-insensitive mode</li>
			<li>Now no pipe ("<code>|</code>") is printed at the end of each link, only a single space ("<code> </code>") is printed</li>
			<li>Now generated code pass the w3.org validation service</li>
			<li>Updated help and about text</li>
		</ul>
		<li>Version 1.2 released on 20091228 by Eduardo Martinez (hexdj)</li>
		<ul>
			<li>Minor update: clarified help text</li>
		</ul>
		<li>Version 1.1</li>
		<ul>
			<li>Fixed notices that were displayed on some servers and other fixes (thanks to plger)</li>
		</ul>
		<li>Version 1.01</li>
		<ul>
			<li>Added Stumbleupon, Buzzup, Blinklist, Mixx, Myspace, LinkedIn and Facebook</li>
			<li>Fixed issue with default images path</li>
			<li>Updated icons</li>
		</ul>
		<li>Version 1.0 released on 20060110 by Paul Hodgson</li>
		<ul>
			<li>The directory the images are stored in can be changed from the default install dir, and the dir defined within the tag</li>
			<li>Cleaned up some code</li>
			<li>Added more comments</li>
		</ul>
		<li>Version 0.3 Beta 1</li>
		<ul>
			<li>Added the <code>submitto</code> parameter, allowing a selection to be made, on which Social Bookmarks are output</li>
			<li>Added the variable <code>$img_dir</code> to the code, so any directory can be used to store the images</li>
		</ul>
		<li>Version 0.2 Beta 1</li>
		<ul>
			<li>Added two parameters, <code>title</code> and <code>target</code></li>
		</ul>
		<li>Version 0.1 Beta 1</li>
		<ul>
			<li>First release</li>
		</ul>
	</ul>
	<?php
}
?>
